'use strict';
angular.module('ib.controllers')
.controller('JobCtrl', function($scope, $rootScope, $stateParams, $ionicPopup, $ionicLoading, RestService, DbService, HelperService, objs, $state, propList, childChildType, objLength, fieldsStatus, JobsFactory, FieldObjFactory, gettext, gettextCatalog, childType, tableViewFieldsMap) {
  $scope.JobName = JobsFactory.job.data.JobName;
  $scope.fieldsStatus = fieldsStatus;
  $scope.childChildType = childChildType;
  $scope.childChildTypes = childChildType + 's';
  $scope.objLength = objLength;
  $scope.propList = propList;
  $scope.tableViewFieldsMap = tableViewFieldsMap;
  $scope.jobId = $stateParams.jobId;
  $scope.childType = childType;
  $scope.childTypes = childType + 's';
  $scope.$on('$stateChangeSuccess', function() {
    $ionicLoading.hide();
  });

  $scope.completeJob = function(id) {
    if (JobsFactory.job.status >= 3) {
      return false;
    }
    $scope.popup = {
      done: false,
      subTitle: gettextCatalog.getString('You will not be able to update this job<br />THIS ACTION IS IRREVERSIBLE'),
      description: false
    };
    // if (HelperService.isOnlineCheck()) {
      $ionicPopup.show({
        title: gettextCatalog.getString('Complete Job'),
        subTitle: $scope.popup.subTitle,
        template: '<ion-checkbox class="checkbox-assertive" ng-model="popup.done">I understand.</ion-checkbox><div class="assertive" ng-show="popup.description">' + gettextCatalog.getString("Please confirm") + '</div>',
        scope: $scope,
        buttons: [{
          text: gettextCatalog.getString('COMPLETE'),
          type: 'button-balanced',
          onTap: function(e) {
            if (!$scope.popup.done) {
              e.preventDefault();
              $scope.popup.description = true;
            } else {
              DbService.updateJobStatus(id, 3);
              $rootScope.$broadcast('jobs.jobUpdate', {id: id, status: 3});

              // $scope.syncData('manual');
              $state.go('app.jobs');
            }
          }
        }, {
          text: gettextCatalog.getString('CANCEL'),
          type: 'button-default'
        }]
      });
    // }
    // else {
    //   $ionicPopup.alert({
    //     title: gettextCatalog.getString('No internet connection'),
    //     okType: 'button-balanced'
    //   });
    // }
  };

  function jobBtnState() {
    var bState;
    switch (JobsFactory.job.status) {
      case 0:
      case 1:
      case 2:
        bState = 'off';
        break;
      // case 3:
      //   bState = 'process';
      //   break;
      case 3:
      case 4:
        bState = 'done';
    }
    return bState;
  }
  $scope.btnState = jobBtnState();

  function jobBtnText() {
    var bText;
    switch (JobsFactory.job.status) {
      case 0:
      case 1:
      case 2:
        bText = gettext('DONE');
        break;
      // case 3:
      //   bText = gettext('SYNC');
      //   break;
      case 3:
      case 4:
        bText = gettext('COMPLETED');
    }
    return bText;
  }
  $scope.btnText = jobBtnText();

  $scope.$on('jobs.jobUpdate', function(){
    $scope.btnText = jobBtnText();
    $scope.btnState = jobBtnState();
  });

  // Exit related mode
  if ($state.current.name == 'app.job.child') {
    FieldObjFactory.exitRelatedMode();
  }

  // function toggleCompleteBtn() {
  //   $scope.completeBtn = $scope.completeBtn == 'DONE' ? 'COMPLETED' : 'DONE';
  //   $scope.btnState = $scope.completeBtn == 'DONE' ? 'off' : 'on';
  // }

})
