angular.module('ib.controllers')
.controller('LoginCtrl', function($scope, $state, AuthenticationService, localStorageService, gettextCatalog) {
  $scope.isLoginState = false;
  $scope.message = "";

  $scope.user = {
    username: localStorageService.get('username') || null,
    password: null
  };

  $scope.login = function() {
    AuthenticationService.login($scope.user);
  };


  $scope.$on('event:auth-forbidden', function(e, rejection) {
    if (rejection.config.url.indexOf($scope.endPointRoot) > -1) {
      $scope.user = {
        username: localStorageService.get('username'),
        password: localStorageService.get('keystring')
      };
      if ($scope.user.username && $scope.user.password) {
        AuthenticationService.login($scope.user);
      }
      else {
        $scope.isLoginState = true;
        $scope.loginModal.show();
      }
    }
  });

  $scope.$on('event:auth-loginConfirmed', function() {
    $scope.message = "";
    // $scope.user.username = null;
    $scope.user.password = null;
    $scope.loginModal.hide();
    $scope.isLoginState = false;
  });

  $scope.$on('event:auth-login-failed', function(e, status) {
    if (!$scope.isLoginState) {
      $scope.isLoginState = true;
      $scope.loginModal.show();
    }
    else {
      var error = "Login failed.";
      if (status == 401) {
        error = gettextCatalog.getString("Invalid Username or Password.");
      }
      $scope.message = error;
    }
  });

})
