angular.module('ib.controllers')
.controller('ObjCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicModal, $ionicLoading, $cordovaCamera, FieldObjFactory, DbService, fieldObj, pics, currObj, $timeout, propList, childType, objLength, sortedListInit, sortedItemId, settings, fieldsStatus, formFieldInfo, $log, JobsFactory, jobInit, $location, $q, parentId, $ionicTabsDelegate, $ionicHistory, objId, tab, GotoService, $filter, fod, gettextCatalog, tableViewFieldsMap, relatedPlots, $cordovaFile) {
  $scope.relatedPlots = relatedPlots;
  $scope.fieldsStatus = fieldsStatus;
  $log.info("ObjCtrl enter time " + Date.now(), {'controllerStartTime' : Date.now()});

  $scope.$on('$stateChangeSuccess', function() {
    var search = $location.search();
    if (!('objId' in search) || !('parentId' in search)) {
      // $scope.loadedViewClass = "loaded-view";
      $location.search({parentId: $scope.parentId,objId: $scope.objId, tab: $state.current.name.replace("app.job.obj.tabs.tab-", "")});
    }
  });

  $scope.$on('$ionicView.afterEnter', function(scopes, states) {
    var path = $location.path();
    if (path.indexOf('tabs') > -1) {
      $scope.tab = $state.current.name.replace('app.job.obj.tabs.tab-', '');
    }
    else if (path.indexOf('quick-edit') > -1) {
      $scope.tab = 'quick-edit';
    }
    if (states.stateParams) { // Otherwise run too early (twice)
      loadedViewHandler();
    }
  });

  $scope.$on('childobj.updated', function() {
    loadedViewHandler();
    GotoService.endGoto();
  });

  var loadedViewHandler = function() {
    $ionicLoading.hide();
    $scope.loadedViewClass = "loaded-view";
    $scope.transitionClass = "";
    $scope.$broadcast('obj.calcContentTop');
  };

  // $scope.$on('objctrl.update', function() {
  // });

  // $scope.$on('obj.viewLeaving', function(event) {
  //   $scope.loadedViewClass = '';
  // });

  // $scope.$on('$ionicView.afterEnter', function (event, toState, toParams, fromState, fromParams) {
  //  $ionicLoading.hide();
  // });

  $scope.$on('$locationChangeSuccess', function (event) {
   
    // Bail if we're not on tabs/quick-edit view
    var path = $location.path();
    if ($state.current.name.indexOf("app.job.obj.tabs.tab") == -1 && path.indexOf('quick-edit') === -1) {
      return;
    }

    var search = $location.search(),
        parentChanged = false,
        childChanged = false,
        tabChanged = false;
    //Check if parent changed
    if ('parentId' in search && search.parentId != $scope.parentId) {
      $scope.parentId = search.parentId;
      parentChanged = true;
    }
    //Check if tab changed
    if ('tab' in search && search.tab != $scope.tab) {
      tabChanged = true;
    }
    //Check if child changed
    if ('objId' in search && search.objId != $scope.objId) {
      childChanged = true;
      $scope.objId = search.objId;
    }

    if (parentChanged) {
      setActiveItem();
      handleRelatedMode();
      setChildChild();
      FieldObjFactory.setParentData($stateParams.jobId, $scope.parentId).then(function() {

        setObjData().then(function() {
          if (tabChanged) {
            $location.path($state.href("app.job.obj.tabs.tab-" + search.tab).replace("#", "")).search({parentId: search.parentId,objId: search.objId, tab: search.tab});
            $scope.tab = search.tab;
          }
          else{
            $scope.$broadcast('objctrl.update');
          }
        });
      });
    }
    else if (childChanged) {
      setActiveItem();
      handleRelatedMode();
      setObjData().then(function() {
        if (tabChanged) {
          $location.path($state.href("app.job.obj.tabs.tab-" + search.tab).replace("#", "")).search({parentId: search.parentId,objId: search.objId, tab: search.tab});
          $scope.tab = search.tab;
        }
        else {
          $scope.$broadcast('objctrl.update');
        }
      });
    }
  });

  function setChildChild() {
    var childFod = FieldObjFactory.getChildFod(JobsFactory.job.data, $scope.objId);
    if (childFod) {
      $scope.childType = FieldObjFactory.getChildType(childFod);
      $scope.childTypes = getPluralStr($scope.childType);
      if (childFod.ScObjChildDefId) {
        var childChildFod = $filter('filter')(JobsFactory.job.data.ScObjDefList.ScObjDef, {ScObjDefId: childFod.ScObjChildDefId
        }, true)[0];
        if (childChildFod) {
          $scope.childChildType = childChildFod.ScObjType;
          $scope.childChildTypes = getPluralStr($scope.childChildType);
        }
        else {
          $scope.childChildType = false
        }
      }
      else {
        $scope.childChildType = false
      }

      $scope.propList = FieldObjFactory.getPropList(childFod);
      $scope.tableViewFieldsMap = FieldObjFactory.getPropListForTableView(childFod);
    }
    else {
      $scope.childType = false;
      $scope.childChildType = false;
      $scope.propList = [];
    }

  }

  function setObjData() {
    var deferred = $q.defer();
    $scope.sortedItemId = FieldObjFactory.getSortedItemId(FieldObjFactory.sortedList, $scope.objId);
    $scope.fieldObj = FieldObjFactory.setFieldObjProp(FieldObjFactory.findObject(JobsFactory.job.data.ScoredObjectsList.ScoredObject, $scope.objId), FieldObjFactory.parentValues);
    $scope.formFieldInfo = FieldObjFactory.getFormFieldInfo($scope.fieldObj);
    $scope.objMeta = FieldObjFactory.getObjectMeta(JobsFactory.job.data, $scope.fieldObj);


    if ('RelatedPlotsList' in $scope.fieldObj) {
      FieldObjFactory.relatedPlots = $scope.fieldObj.RelatedPlotsList.RelatedPlot;
      if (!(Array.isArray(FieldObjFactory.relatedPlots))) {
        FieldObjFactory.relatedPlots = [FieldObjFactory.relatedPlots];
      }


      // $scope.relatedPlots = FieldObjFactory.relatedPlots.length;
      $scope.relatedPlots = FieldObjFactory.relatedPlots.length;
    }
    else {
      FieldObjFactory.relatedPlots = false;
      $scope.relatedPlots = false;
    }

    $scope.disabledBtn = false;
    FieldObjFactory.setFod(JobsFactory.job.data, $scope.objId);
    DbService.getFieldsStatus($scope.objId).then(function(fs) {
      $scope.fieldsStatus = fs;
      FieldObjFactory.getItemStatus($scope.objId, FieldObjFactory.sortedList[$scope.sortedItemId]).then(function(res) {
        $scope.currObj = res;
        FieldObjFactory.setJobFieldChildes($stateParams.jobId, $scope.objId).then(function(res) {
          $scope.objLength = FieldObjFactory.objs.length;
          DbService.getJobImages($stateParams.jobId, $scope.objId).then(function(images){
            $scope.pics = images;
            setNextAndBackState();
            deferred.resolve();
          });
        });
      });
    });
    return deferred.promise;
  }

  // Plural child type
  function getPluralStr(str) {
    // ToDo: English only, this will need fix for other languages.
    // Since the 'childType' comes from the job, the job will need to send the
    // pluralized string as well.
    return str + 's';
  }

  $scope.tableViewFieldsMap = tableViewFieldsMap;

  // Parnet codepropList
  $scope.settings = settings;
  // Obj code
  $scope.parentId = parentId;
  $scope.formFieldInfo = formFieldInfo;

  $scope.sortedItemId = sortedItemId;
  $scope.settings = settings;
  $scope.objLength = objLength;
  $scope.propList = propList;
  $scope.pics = pics;
  $scope.currObj = currObj;
  setChildChild();

  $scope.fieldObj = fieldObj;
  $scope.jobId = $stateParams.jobId;
  $scope.objId = objId;
  $scope.tab = tab;
  $scope.disabledBtn = false;
  $scope.objMeta = FieldObjFactory.getObjectMeta(JobsFactory.job.data, $scope.fieldObj);
  $scope.jobDone = JobsFactory.job.status >= 3 ? true : false;
  setNextAndBackState();
  $scope.limitInfoItems = true;
  $scope.loadedViewClass = '';
  $scope.transitionClass = '';

  setActiveItem();
  handleRelatedMode();

  $scope.$broadcast('objctrl.update');

  $scope.goToParent = function() {
    if ('parentId' in $scope && $scope.parentId != 0) {
      var parent = FieldObjFactory.findObject(JobsFactory.job.data.ScoredObjectsList.ScoredObject, $scope.parentId);
      GotoService.goTo(parent.ParentUniqueId, $scope.parentId, "items");
    }
    else {
      $ionicLoading.show();
      $state.go('app.job.child', {
        jobId: $scope.jobId
      });
    }
  };

  $scope.transitionTo = function(dir) {
    // Move item using css transform.
    $scope.transitionClass = 'transition-to transition-' + dir;
    $scope.loadedViewClass = '';
    $timeout(function() {
      $scope.transitionClass = '';
    }, 400);
    $scope.goTo(dir);
  };

  $scope.goTo = function(dir) {

    var destObj;
    if (dir == 'next') {
      destObj = $scope.sortedItemId + 1;
    }
    else {
      destObj = $scope.sortedItemId - 1;
    }

    var goToId = FieldObjFactory.sortedList[destObj] ? FieldObjFactory.sortedList[destObj].id : false;

    if (goToId) {
      $scope.$broadcast('objctrl.transition');
      $scope.loadedViewClass = '';
      $ionicLoading.show();
      GotoService.goTo($scope.parentId, goToId, $scope.tab, "trans");
    }

  };

  // Quick edit
  $scope.toggleQuickEdit = function() {
    if ($location.path().indexOf('quick-edit') === -1) {
      // Coming from another view, go to quick edit.
      GotoService.goTo($scope.parentId, $scope.objId, 'quick-edit');
    }
    else {
      // Quick edit, go to tabs.
      GotoService.goTo($scope.parentId, $scope.objId, 'edit');
    }
  };

  // Pictures
  $scope.getPics = function() {
    DbService.getJobImages($scope.jobId, $scope.objId).then(function(images) {
      $scope.pics = images;
    });
  };

  $scope.$on('pics.newPic', function() {
    $scope.pics = $scope.getPics();
  });

  // Take picture
  $scope.newPic = function() {
    var options = {
      quality: 100,
      correctOrientation: true,
      saveToPhotoAlbum: true
    };
    $cordovaCamera.getPicture(options).then(function(imageURI) {
      if (imageURI) {
        DbService.insertJobImage($scope.jobId, $scope.objId, 0, Date.now() / 1000, imageURI, $scope.fieldObj);
        $scope.pics = $scope.getPics();
      }
    }, function(err) {
      if (err != "Camera cancelled.") {
        $ionicPopup.alert({
          title: gettextCatalog.getString('Something went wrong'),
          template: err
        });
      }
    });
  };
//  $scope.newPic = function() {
//// capture callback
//    var captureSuccess = function(mediaFiles) {
//      var i, path, len;
//      for (i = 0, len = mediaFiles.length; i < len; i += 1) {
//        path = mediaFiles[i].fullPath;
//        // do something interesting with the file
//      }
//    };
//
//// capture error callback
//    var captureError = function(error) {
//      navigator.notification.alert('Error code: ' + error.code, null, 'Capture Error');
//    };
//
//// start audio capture
//    navigator.device.capture.captureImage(captureSuccess, captureError, {limit:2});
//
////    var options = {
////      quality: 100,
////      correctOrientation: true,
////      saveToPhotoAlbum: true
////    };
////    $cordovaCamera.getPicture(options).then(function(imageURI) {
////      if (imageURI) {
////        DbService.insertJobImage($scope.jobId, $scope.objId, 0, Date.now() / 1000, imageURI, $scope.fieldObj);
////        $scope.pics = $scope.getPics();
////      }
////    }, function(err) {
////      console.err(err);
////      $ionicPopup.alert({
////        title: gettextCatalog.getString('Something went wrong'),
////        template: gettextCatalog.getString('Unable to take picture.')
////      });
////    });
//  };

  // Add new item
  $scope.$on('obj.updateLists', function() {
    FieldObjFactory.setJobFieldChildes($scope.jobId, $scope.objId).then(function(objs) {
      $scope.objLength = FieldObjFactory.objs.length;
      $timeout(function(){
        $ionicLoading.hide();
        $scope.$broadcast('childList.refilter');
      });
    });
  });

  // Item info pane
  $scope.$on('$ionicView.afterEnter', function(event) {
    if (angular.element(document.querySelector('[ib-content-top]:not(.processed-content-top)')).length) {
      FieldObjFactory.getInfoState($scope.jobId).then(function(infoPaneExpanded) {
        $scope.limitInfoItems = infoPaneExpanded ? false : true;
        // $scope.calcInfoPaneHeight();
        $timeout(function() {
          $scope.$broadcast('obj.calcContentTop');
        });
        angular.element(document.querySelector('[ib-content-top]')).addClass('processed-content-top');
      });
    }
  });
  // Moved to directive
  $scope.calcInfoPaneHeight = function() {
    // $timeout(function() {
    //   var headerEl = document.getElementsByTagName('ion-header-bar')[0],
    //       tabsEl = document.getElementsByClassName('tabs')[0]
    //       infoPaneEl = document.getElementById('info-pane'),
    //       contentTop = 0;
    //   contentTop += angular.isDefined(headerEl) ? headerEl.offsetHeight : 0;
    //   contentTop += angular.isDefined(tabsEl) ? tabsEl.offsetHeight : 0;
    //   contentTop += angular.isDefined(infoPaneEl) ? infoPaneEl.offsetHeight : 0;
    //   $scope.contentTop = contentTop + 'px';
    // });
  }
  $scope.toggleShowMore = function(event) {
    event.stopPropagation();
    FieldObjFactory.toggleInfoState($scope.jobId).then(function(infoPaneExpanded) {
      $scope.limitInfoItems = infoPaneExpanded ? false : true;
      $timeout(function() {
        $scope.$broadcast('obj.calcContentTop');
        // $scope.calcInfoPaneHeight();
      });
    });
  }
  $scope.$broadcast('obj.calcContentTop');
  // $scope.contentTop = $scope.calcInfoPaneHeight();

  // Next/Back buttons state
  function setNextAndBackState() {
    if (!FieldObjFactory.sortedList[$scope.sortedItemId + 1]) {
      $scope.disabledNext = true;
    }
    else {
      $scope.disabledNext = false;
    }

    if (!FieldObjFactory.sortedList[$scope.sortedItemId - 1]) {
      $scope.disabledPrev = true;
    }
    else {
      $scope.disabledPrev = false;
    }
  }

  // Active item
  function setActiveItem() {
    FieldObjFactory.setActiveItem($scope.jobId, $scope.parentId, $scope.objId);
  }

  // Favorites
  $scope.toggleFavorite = function() {
    var favState;
    favState = FieldObjFactory.toggleFavorite($scope.jobId, $scope.objId);
    $scope.currObj.fav = favState;
    FieldObjFactory.sortedList[$scope.sortedItemId].fav = favState;
    DbService.updateJobFieldsChildes($scope.jobId, $scope.parentId, FieldObjFactory.orderdlist);
  };

  // History modal
  $scope.historyModal = function(form) {
    $ionicModal.fromTemplateUrl('templates/history-modal.html', function(modal) {
      $scope.gridModal = modal;
      if (form && (form.historyList || form.History)) {
        // ToDo: Unify the structure of the form element & info element
        $scope.historyTitle = form.title || form.Name;
        $scope.historyList = form.historyList || form.History;
        $scope.historyUnit = form.unit || form.Unit;
        $scope.gridModal.show();
      }
    }, {
      scope: $scope,
      animation: 'slide-in-up'
    });
  };
  // close video modal
  $scope.closeHistoryModal = function() {
    $scope.gridModal.hide();
  };

  $scope.$on('$destroy', function() {
    if ($scope.gridModal) {
      $scope.gridModal.remove();
    }
  });

  // Related modal
  $scope.openRelatedList = function(form) {
    $ionicModal.fromTemplateUrl('templates/related-modal.html', function(modal) {
      $scope.relatedModal = modal;
      FieldObjFactory.getRelatedItems($stateParams.jobId).then(function(relatedItems){
        $scope.relatedItems = relatedItems;
        $scope.relatedModal.show();
      })
    }, {
      scope: $scope,
      animation: 'slide-in-up'
    });
  };
  // close video modal
  $scope.closeRelatedList = function() {
    $scope.relatedModal.hide();
  };

  $scope.$on('$destroy', function() {
    if ($scope.relatedModal) {
      $scope.relatedModal.remove();
    }
  });

  // Related plots
  function handleRelatedMode() {
    var rid = FieldObjFactory.getRelatedMode();
    if (rid == $scope.objId) {
      $scope.exitRelatedMode();
      $scope.relatedMode = false;
    }
    else if (rid) {
      $scope.relatedMode = true;
    }
  }
  
  $scope.enterRelatedMode = function () {
    FieldObjFactory.enterRelatedMode($scope.objId);
  }

  $scope.exitRelatedMode = function () {
    FieldObjFactory.exitRelatedMode();
  }

  $scope.backToRelated = function () {
    var rid = FieldObjFactory.getRelatedMode();
    GotoService.goTo(0, rid, 'edit');
  }

});
