angular.module('ib.controllers')
.controller('ObjItemsCtrl', function($scope, $stateParams, $state, $ionicModal, $ionicPopup, $ionicLoading, $cordovaBarcodeScanner, FieldObjFactory, DbService, JobsFactory, $location, GotoService, gettextCatalog) {
  var addItemPopup;
  function resetDelete() {
    // if ($scope.objs2delete) { // WTF - this breaks the flow between tabs
    FieldObjFactory.objs.filter(function( obj ) {
        return obj.toDelete === true;
      }).forEach(function(obj) {
        delete obj.toDelete;
      });
      $scope.objs2delete = 0;
      // Should we trigger this here?
      $scope.$emit('obj.updateLists');
    // }
  }
  $scope.$on('childList.resetDelete', function() {
    resetDelete();
  });

  function initScope() {
    $scope.newItems = {};
    $scope.newItems.number = 1;
    $scope.newItems.preDefinedID = '';
    $scope.validationError = false;
    $scope.objs2delete = 0;
    resetDelete();
  }
  $scope.$on('objctrl.update', function() {
    initScope();
  })
  initScope();

  $scope.initAddPopup = function() {
    // Get preDefinedIDs
    $scope.preDefinedIDs = FieldObjFactory.fod.preDefinedIDs;
  }

  // Open new item popup
  $scope.openNewItemPopup = function(event) {
    $scope.addLocked = false;
    $scope.newItems.preDefinedID = '';
    $scope.resetItems();

    if ($scope.fieldObj.numChildsToAdd && !FieldObjFactory.getUsedNumChildsToAdd($scope.jobId, $scope.objId)) {
      $scope.createItems($scope.fieldObj.numChildsToAdd, $scope.newItems.number);
    }

    $ionicModal.fromTemplateUrl('templates/add-new-item.html', function(modal) {
        addItemPopup = modal;
        addItemPopup.show();
      },
      {
        scope: $scope,
        animation: 'slide-in-up',
        focusFirstInput: true,
        backdropClickToClose: false,
        hardwareBackButtonClose: false
      }
    );
    //Be sure to cleanup the modal by removing it from the DOM
    $scope.$on('$destroy', function() {
      addItemPopup.remove();
    });

    $scope.addItemPopupSubmit = function () {
      if (!$scope.addLocked) {
        $scope.addLocked = true;
        addItems($scope.newItems.items);
      }
    }

    $scope.addItemPopupHide = function () {
      addItemPopup.hide();
    }

    // addItemPopup = $ionicPopup.show({
    //   templateUrl: 'templates/add-new-item.html',
    //   scope: $scope,
    //   buttons: [
    //     {
    //       text: gettextCatalog.getString('ADD'),
    //       type: 'button-balanced',
    //       onTap: function(e) {
    //         e.preventDefault();
    //         if (!$scope.addLocked) {
    //           $scope.addLocked = true;
    //           addItems($scope.newItems.items);
    //         }
    //       }
    //     },
    //     { text: gettextCatalog.getString('CANCEL') }
    //   ]
    // });
  };

  $scope.setPreDefinedID = function() {
    $scope.validationError = false;
    $scope.newItems.items = [{suggestedTitle: $scope.newItems.preDefinedID}];
    $scope.newItems.items
      .forEach(function(item) {
        if (!validateUniqueId(item.suggestedTitle)) {
          item.validationError = true;
          $scope.validationError = true;
        }
      });
    $scope.$broadcast('event:updateItemsLength');
  }

  function getNextAvailableID(addingNewItem) {

    // Initial title is the number of existing items + number of new items + 1 for the current item.
    var num = FieldObjFactory.objs.length;

    // If we have a bunch of newItems with suggestedTitle, count them.
    if ($scope.newItems && $scope.newItems.items) {
      var hasSuggestedTitle = $scope.newItems.items.filter(function ( obj ) {
        return obj.suggestedTitle;
      });
      num = num + hasSuggestedTitle.length;
    }

    // While creating an extra item, count it.
    if (addingNewItem) {
      num = num + 1;
    }
    else if (num == 0) {
      num = 1;
    }

    var found = true,
        title = num;
    // Search if 'title' exist in $scope.objs
    while (angular.isDefined(found)) {
      title = num;

      found = FieldObjFactory.objs.filter(function ( obj ) {
        return obj.title == title;
      })[0];

      // Now search also in the "newItems"
      if (angular.isUndefined(found) && $scope.newItems && $scope.newItems.items && $scope.newItems.items.length) {
        found = $scope.newItems.items.filter(function ( obj ) {
          return obj.id == title ||  obj.suggestedTitle == title;
        })[0];
      }

      num += 1;
    };

    return title;
  }

  $scope.$on('event:updateItemsLength', function() {
    if ($scope.newItems.number) {
      $scope.newItems.number = $scope.newItems.items.length;
    }
  });

  $scope.pushItem = function() {
    if ($scope.newItems.preDefinedID) {
      $scope.newItems.preDefinedID = '';
      $scope.resetItems();
    }
    $scope.newItems.items.push({
      suggestedTitle: getNextAvailableID(true)
    });
    $scope.$broadcast('event:updateItemsLength');
  }

  $scope.popItem = function() {
    if ($scope.newItems.items.length > 1) {
      $scope.newItems.items.pop()
    }
    $scope.$broadcast('event:updateItemsLength');
  }

  $scope.createItems = function(newVal, oldVal) {
    if (isNaN(newVal)) {
      return;
    }
    var oldVal = oldVal || 1;
        diff = newVal - oldVal;
    if (diff > 0) {
      for (var i = 0; i < diff; i++) {
        $scope.pushItem()
      }
    }
    else if (diff < 0) {
      for (var i = 0; i > diff; i--) {
        $scope.popItem();
      }
    }
  }

  $scope.resetItems = function() {
    $scope.validationError = false;
    $scope.newItems.items = [];
    $scope.pushItem();
    $scope.$broadcast('event:updateItemsLength');
  }

  function validateUniqueId(title) {
    for (var i = 0; i < FieldObjFactory.objs.length; i++) {
      if (FieldObjFactory.objs[i].title.toString().trim() === title.trim()) {
        return false;
      }
    }
    var foundInNew = 0;
    for (var i = 0; i < $scope.newItems.items.length; i++) {
      if ($scope.newItems.items[i].hasOwnProperty('id')) {
        if ($scope.newItems.items[i].id == title) {
          foundInNew++;
        }
      }
      else if ($scope.newItems.items[i].hasOwnProperty('suggestedTitle')) {
        if ($scope.newItems.items[i].suggestedTitle == title) {
          foundInNew++;
        }
      }
      if (foundInNew > 1) {
        return false;
      }
    }
    return true; // Unique
  }

  $scope.reValidateNewItems = function() {
    // Remove suggested items
    $scope.newItems.items
      .forEach(function(item) {
        delete item.suggestedTitle;
      });
    // Validate IDs
    $scope.validationError = false;
    $scope.newItems.items
      .filter(function(item) {
        return item.id;
      })
      .forEach(function(item) {
        item.validationError = false;
        if (!validateUniqueId(item.id)) {
          item.validationError = true;
          $scope.validationError = true;
        }
      });
    // Updated suggested items
    $scope.newItems.items
      .filter(function(item) {
        return !item.id;
      })
      .forEach(function(item) {
        item.validationError = false;
        item.suggestedTitle = getNextAvailableID();
      });
  }

  function addItems(items) {
    var titles = [];
    for (var i = 0; i < items.length; i++) {
      var title;
      if (items[i].id) {
        title = items[i].id.toString();
      }
      else {
        title = items[i].suggestedTitle.toString();
      }
      titles.push(title);
    }
    if ($scope.validationError == false) {

      $ionicLoading.show();
      FieldObjFactory.addNewObjects(JobsFactory.job, $scope.objId, titles).then(function(newObjs) {
        addItemPopup.hide();
        $scope.addLocked = false;
        for (var i = 0; i < newObjs.length; i++) {
          FieldObjFactory.objs.push(FieldObjFactory.getObjectsListItemInfo(JobsFactory.job.data, newObjs[i], FieldObjFactory.getChildFod(JobsFactory.job.data, $scope.objId)));
        }
        DbService.updateJobFieldsChildes($scope.jobId, $scope.objId, FieldObjFactory.objs);
        FieldObjFactory.sortedList[$scope.sortedItemId].childObjs = FieldObjFactory.objs.filter(function (obj) { return obj.deleted !== true; }).length;

        DbService.updateJobFieldsChildes($scope.jobId, $scope.parentId, FieldObjFactory.orderdlist);

        if ($scope.newItems.items.length > 1) {
          if ($scope.fieldObj.numChildsToAdd) {
            FieldObjFactory.usedNumChildsToAdd($scope.jobId, $scope.objId);
          }
        }
        else {
          GotoService.goTo(newObjs[0].ParentUniqueId, newObjs[0].ObjectUniqueId, "edit");
        }

        $scope.$emit('obj.updateLists');

        // Cleanup
        $scope.newItems.preDefinedID = '';
        $scope.resetItems();
      });
    }
    else {
      $scope.addLocked = false;
    }
  }

  $scope.toggleItemDeletion = function(objId) {
    var obj = FieldObjFactory.objs.filter(function( obj ) {
      return obj.id == objId;
    })[0];
    if (obj) {
      // Flag it
      obj.toDelete = obj.toDelete ? false : true;
      // Counter
      obj.toDelete ? $scope.objs2delete++ : $scope.objs2delete--;
    }
  };

  $scope.deleteObjs = function() {
    $scope.popup = {
      done: false,
      subTitle: gettextCatalog.getString('THIS ACTION IS IRREVERSIBLE'),
      description: false
    };
    $ionicPopup.show({
      title: gettextCatalog.getString('Delete') + ' ' + ($scope.objs2delete > 1 ? $scope.childTypes : $scope.childType),
      subTitle: $scope.popup.subTitle,
      template: '<ion-checkbox class="checkbox-assertive" ng-model="popup.done">' + gettextCatalog.getString('I understand.') + '</ion-checkbox><div class="assertive" ng-show="popup.description">' + gettextCatalog.getString('Please confirm') + '</div>',
      scope: $scope,
      buttons: [{
        text: gettextCatalog.getString('DELETE'),
        type: 'button-assertive',
        onTap: function(e) {
          if (!$scope.popup.done) {
            e.preventDefault();
            $scope.popup.description = true;
          } else {
            // ToDo: update parent (counters);
            FieldObjFactory.objs.forEach(function(obj, index, objs) {
              if (obj.toDelete) {
                obj.deleted = true;
                DbService.updateJobFieldIsNew(obj.id, 2);
                delete obj.toDelete;
              }
            });
            DbService.updateJobFieldsChildes($scope.jobId, $scope.objId, FieldObjFactory.objs);
            resetDelete();
            FieldObjFactory.sortedList[$scope.sortedItemId].childObjs = FieldObjFactory.objs.filter(function (obj) { return obj.deleted !== true; }).length;
            DbService.updateJobFieldsChildes($scope.jobId, $scope.parentId, FieldObjFactory.orderdlist);
            // DbService.updateJobSyncStatus($scope.jobId, 0).then(function(){
              $scope.$emit('obj.updateLists');
            // });
          }
        }
      }, {
        text: gettextCatalog.getString('CANCEL'),
        type: 'button-default'
      }]
    });
  }

  $scope.scanNewItemQR = function() {
    $cordovaBarcodeScanner
      .scan()
      .then(function(barcodeData) {
        $scope.newItems.items[0].id = barcodeData.text;
      }, function(error) {
        $ionicPopup.alert({
          title: gettextCatalog.getString('Something went wrong'),
          template: gettextCatalog.getString('Unable to scan the QR code.')
        });
      });
  }

})
