'use strict';
angular.module('ib.controllers')

.controller('ObjQuickEditCtrl', function($scope, $window, $log, $filter, quickFormObject, FieldObjFactory, $stateParams, GotoService, $timeout, $ionicModal, JobsFactory, $location) {

  $scope.$on('$locationChangeSuccess', function(event, url) {
    if (url.indexOf('/quick-edit') > -1) {
      $scope.activeIndex = 0;
      $scope.horzScroll = '0px';
    }
  });

  $scope.quickEditObjId = $scope.objId;
  $scope.$on('$stateChangeSuccess', function(event, toState) {
    if (toState.url == '/quick-edit' && $scope.quickEditObjId != $scope.objId) {
      $scope.activeIndex = 0;
      $scope.horzScroll = '0px';
      $scope.$emit('objctrl.update');
    }
  });

  $scope.$on('objctrl.update', function() {
    $scope.quickEditFieldsMap = initFieldsMap();
    FieldObjFactory.getProcessedForm($stateParams.jobId, 1).then(function(formObject){
      // COMMENTED TO REMOVE DECISIONS FIELDS FROM QUICK EDIT
      // FieldObjFactory.getProcessedForm($stateParams.jobId, 2).then(function(decisionsFormObject){
      //   quickFormObject = formObject.concat(decisionsFormObject);
        quickFormObject = formObject;
        GotoService.endGoto();
        quickEditBtnsState();
        $scope.quickEditObjId = $scope.objId;
        $scope.$emit('childobj.updated');
        $scope.$emit('quickFormObject.rebuild');
      // });
    });
  });

  $scope.$on('quickFormObject.rebuild', function() {
    // Filter quickFormObject using the values in quickEditFieldsMap
    $scope.quickFormObject = $filter('filter')(quickFormObject, function(value) {
      // Return the right value from $scope.quickEditFieldsMap
      return $filter('filter')($scope.quickEditFieldsMap, {pd: value.pd})[0].showInQuickEdit;
    });
    $scope.quickFormObjectLength = $scope.quickEditFieldsMap.filter(function (el) {
      return el.showInQuickEdit === true;
    }).length;
    $scope.$broadcast('quickFormObject.autoFocus');
  });

  $log.info('ObjQuickEditCtrl enter time ' + Date.now(), {'controllerStartTime' : Date.now()});

  // Generate initial map
  var initFieldsMap = function() {
    // ToDo: we can move this to the sqlite DB / Job cache.
    var fieldsMap = FieldObjFactory.getQuickEditFieldsMap($scope.jobId, $scope.objMeta.Type);
    if (!fieldsMap.length) {
      quickFormObject.forEach(function(field) {
        fieldsMap.push({
          pd: field.pd,
          title: field.title,
          showInQuickEdit: (angular.isUndefined(field.showInQuickEdit) || field.showInQuickEdit === true)
        });
      });
    }
    return fieldsMap;
  };

  $scope.quickEditFieldsMap = initFieldsMap();
  $scope.$emit('quickFormObject.rebuild');

  $scope.activeIndex = 0;
  $scope.horzScroll = '0px';
  quickEditBtnsState();

  $scope.quickEditBtns = function(dir) {
    var lastItem = $scope.quickFormObject.length - 1,
        shouldScroll = false;
    if ($scope.parentHasNextWithChild && dir === 'next') {
			FieldObjFactory.getNextItem(JobsFactory).then(function (res) {
				GotoService.goTo(res.parentId, res.objId, $scope.tab);
			});
    } else if($scope.parentHasPrevWithChild && dir === 'prev') {
			FieldObjFactory.getPrevItem(JobsFactory).then(function (res) {
				GotoService.goTo(res.parentId, res.objId, $scope.tab);
			});
		}

    else if ($scope.activeIndex === lastItem && dir === 'next') {
      $scope.transitionTo('next');
    }
    else if ($scope.activeIndex === 0 && dir === 'prev') {
      $scope.transitionTo('prev');
    }
    else {
      $scope.activeIndex += (dir === 'next') ? 1 : -1;
      shouldScroll = true;
    }

    if (shouldScroll) {
      $scope.horzScroll = ($scope.activeIndex * -100) + '%';
      $timeout(function() {
        var focusable = document
                        .querySelectorAll('.quick-edit-form .form-repeat')[$scope.activeIndex]
                        .querySelector('[tabindex]');
        if (focusable && focusable.focus) {
          $timeout(function() {
            focusable.focus();
            // focusable.click();
            if($window.cordova && $window.cordova.plugins.Keyboard) {
              cordova.plugins.Keyboard.show();
            }
          }, 400);
        }
      });
    }

    quickEditBtnsState();

  };

  // Next/Prev buttons state
  function quickEditBtnsState() {
    $scope.parentHasNextWithChild = false;
    $scope.parentHasPrevWithChild = false;
    $scope.prevSuffix = '';
    $scope.nextSuffix = '';

    $scope.disabledQuickPrev = false;
    $scope.disabledQuickNext = false;

    // if it's the first form element.
    if ($scope.activeIndex < 1) {
      if ($scope.relatedMode) {
        $scope.disabledQuickPrev = true;
      }
      else if (!FieldObjFactory.sortedList[$scope.sortedItemId - 1]) {
        FieldObjFactory.getPrevItem(JobsFactory).then(function (res) {
          $scope.parentHasPrevWithChild = res !== false;
          if ($scope.parentHasPrevWithChild) {
            $scope.prevSuffix = res.parent.type.toUpperCase();
          }
          else {
            $scope.disabledQuickPrev = true;
          }
        })
      }
    }

    // If it's the last form item.
    if ($scope.activeIndex >= $scope.quickFormObjectLength - 1) {
      if ($scope.relatedMode) {
        $scope.disabledQuickNext = true;
      }
			else if (!FieldObjFactory.sortedList[$scope.sortedItemId + 1]) {
				FieldObjFactory.getNextItem(JobsFactory).then(function (res) {
					$scope.parentHasNextWithChild = res !== false;

					if ($scope.parentHasNextWithChild) {
						$scope.nextSuffix = res.parent.type.toUpperCase();
					}
					else {
						$scope.disabledQuickNext = true;
					}
				});
			}
		}
	}

  $scope.quickEditToggleMenu = function() {
    $ionicModal.fromTemplateUrl('templates/quick-edit-menu.html', function(modal) {
      $scope.quickEditMenu = modal;
      $scope.quickEditMenu.show();
    }, {
      scope: $scope,
      animation: 'slide-in-up'
    });
  };
  // close video modal
  $scope.closeQuickEditMenu = function() {
    $scope.quickEditMenu.hide();
  };
  $scope.$on('modal.hidden', function() {
    $scope.$emit('quickFormObject.rebuild');
    FieldObjFactory.setQuickEditFieldsMap($scope.jobId, $scope.objMeta.Type, $scope.quickEditFieldsMap);
  });
  $scope.$on('$destroy', function() {
    if ($scope.quickEditMenu) {
      $scope.quickEditMenu.remove();
    }
  });

  $scope.checkAll = true;
  $scope.quickEditMenuToggleCheckAll = function(checkAll) {
    $scope.checkAll = checkAll;
    var keys = Object.keys($scope.quickEditFieldsMap);
    for (var i = 0; i < keys.length; i++) {
      $scope.quickEditFieldsMap[keys[i]].showInQuickEdit = checkAll;
    }
  };

  $scope.quickEditAutoAdvance = function(formField) {
    if (formField.type && ['select', 'boolean', 'images'].indexOf(formField.type) != -1) {
      $scope.quickEditBtns('next');
    }
  };

});
