angular.module('ib.controllers')
.controller('PicsCtrl', function($scope, $ionicModal, $ionicPopup, DbService, gettextCatalog) {

  function initScope() {
    $scope.deleteMode = false;
    $scope.transitionClass = "";
  }
  $scope.$on('objctrl.update', function() {
    initScope();
    $scope.$emit('childobj.updated');
  })
  initScope();
  function toggleDelete(imgUrl) {
    var pic = $scope.pics.filter(function( pic ) {
      return pic.imgUrl == imgUrl;
    })[0];
    pic.toDelete = pic.toDelete ? false : true;
    $scope.pics2delete = $scope.pics.filter(function( pic ) {
      return pic.toDelete == true;
    });
    if ($scope.pics2delete.length == 0) {
      $scope.deleteMode = false;
    }
  }

  // Enter delete mode
  $scope.imgHold = function(imgUrl) {
    $scope.deleteMode = true;
    toggleDelete(imgUrl);
  };

  // Open image modal OR mark for deletion
  $scope.imgTap = function(imgUrl) {
    if ($scope.deleteMode) {
      toggleDelete(imgUrl);
    }
    else {
      $ionicModal.fromTemplateUrl('templates/img-modal.html', function(modal) {
        $scope.gridModal = modal;
        $scope.imgUrl = imgUrl;
        $scope.gridModal.show();
      }, {
        scope: $scope,
        animation: 'slide-in-up'
      });
    }
  };
  // Close image modal
  $scope.closeImgModal = function() {
    $scope.gridModal.hide();
  };
  $scope.$on('$destroy', function() {
    if ($scope.gridModal) {
      $scope.gridModal.remove();
    }
  });

  // Delete pics
  $scope.deletePics = function() {
    $scope.popup = {
      done: false,
      subTitle: gettextCatalog.getString('THIS ACTION IS IRREVERSIBLE'),
      description: false
    };
    $ionicPopup.show({
      title: gettextCatalog.getString('Delete Images'),
      subTitle: $scope.popup.subTitle,
      template: '<ion-checkbox class="checkbox-assertive" ng-model="popup.done">I understand.</ion-checkbox><div class="assertive" ng-show="popup.description">' + gettextCatalog.getString('Please confirm') + '</div>',
      scope: $scope,
      buttons: [{
        text: gettextCatalog.getString('DELETE'),
        type: 'button-assertive',
        onTap: function(e) {
          if (!$scope.popup.done) {
            e.preventDefault();
            $scope.popup.description = true;
          } else {
            DbService.deleteJobImages($scope.pics2delete).then(function() {
              $scope.pics2delete = [];
              $scope.deleteMode = false;
              $scope.$emit('pics.newPic');
            });
          }
        }
      }, {
        text: gettextCatalog.getString('CANCEL'),
        type: 'button-default'
      }]
    });

  };

})
