angular.module('ib.directives')
.directive('breadcrumbs', function(FieldObjFactory, JobsFactory, $state, $ionicLoading, $location, GotoService, gettextCatalog) {

  var jobData, objects;

  var getBreadObj = function(objects, objId) {
    var breadObj = FieldObjFactory.findObject(objects, objId);
    if (breadObj) {
      var breadObjFod = FieldObjFactory.getFod(jobData, objId);
      breadObj.type = breadObjFod.ScObjType;
    }
    return breadObj;
  }

  var breadcrumbsHandler = function(scope, element, attrs) {
    scope.$on('objctrl.update', function() {
      setData();
    })
    scope.$on('$stateChangeSuccess', function() {
      setData();
    })
    jobData = JobsFactory.job.data;
    objects = jobData.ScoredObjectsList.ScoredObject;

    function setData() {
      scope.breadcrumbs = [];
      // Current object
      var breadObj = getBreadObj(objects, scope.currObj.id);
      scope.breadcrumbs.unshift(breadObj);
      // Iterate parent objets
      do {
        breadObj = getBreadObj(objects, breadObj.ParentUniqueId);
        if (breadObj) {
          scope.breadcrumbs.unshift(breadObj);
        }
      } while (breadObj);
      // Job element
      var jobCrumb = {
        ObjectName: jobData.JobName,
        type: gettextCatalog.getString("Job"),
        ObjectUniqueId: "job",
        ObjectId: jobData.JobId

      }

      scope.breadcrumbs.unshift(jobCrumb);
      FieldObjFactory.setBC(scope.breadcrumbs);
      // Jobs element
      var jobsCrumb = {
        ObjectName: gettextCatalog.getString("Jobs"),
        ObjectUniqueId: "jobs"
      }
      scope.breadcrumbs.unshift(jobsCrumb);

    }
    setData();
    // Handle navigation
    scope.goToWithLoading = function(objId, parentUniqueId) {

      if (objId == scope.currObj.id) {
        return false;
      }
//      scope.$emit('obj.viewLeaving');
      $ionicLoading.show();
      if (objId == "jobs") {
        $state.go('app.jobs');
      }
      else if (objId == "job") {
        $state.go('app.job.child', {
          jobId: scope.jobId
        });
      }
      else {
        GotoService.goTo(parentUniqueId,objId, "edit");
      }
    }

  }

  return {
    restrict: 'E',
    link: breadcrumbsHandler,
    template: '<ul class="breadcrumb"><li ng-repeat=\'bc in breadcrumbs\' ng-class="{\'active\': {{$last}} }"><a on-tap-hold="goToWithLoading(bc.ObjectUniqueId, bc.ParentUniqueId)">{{bc.type}} {{bc.ObjectName}}</a><span class="divider" ng-show="! $last"> >> </span></li></ul>'
  };
});
