angular.module('ib.directives')
.directive('historicValue', function($parse) {

  function renderStyledValue(val, style, cls) {
    cls = cls || '';
    return '<span class="' + cls + ' display-' + style + '">' + val + '</span>'
  }

  function historicValueLink(scope, element, attrs) {
    var hasValue = false;
    var output = '';
    var propData = $parse(attrs.propData);
    var prop = propData(scope);

    if (!prop) {
      return;
    }

    if (prop.oldval != "") {
      hasValue = true;
      output += renderStyledValue(prop.oldval, prop.displayStyle);
    }
    else if (prop.femaleParentVal != "" || prop.maleParentVal != "") {
      hasValue = true;
      output += renderStyledValue(prop.femaleParentVal, prop.femaleParentDisplayStyle, 'female-parent ion-female');
      if (prop.femaleParentVal != "" && prop.maleParentVal != "") {
        output += ' / ';
      }
      output += renderStyledValue(prop.maleParentVal, prop.maleParentDisplayStyle, 'male-parent ion-male');
    }

    if (hasValue) {
      element.replaceWith('<span class="oldval">(' + output + ')</span>');
    }

  }

  return {
    link: historicValueLink
  };
});
