'use strict';
angular.module('ib.directives')
.directive('ibAutoFocus', function($timeout, $window) {

  return {
    restrict: 'A',
    link: function(scope, element) {

      // Auto focus every time the quick-edit panel opens.
      scope.$on('$stateChangeSuccess', function(event, toState) {
        if (toState.url == '/quick-edit') {
          $timeout(function() {
            autoFocus();
          });
        }
      });

      // Auto focus after the quick-edit object updates.
      scope.$on('quickFormObject.autoFocus', function() {
        $timeout(function() {
          autoFocus();
        }, 1000);
      });

      var autoFocus = function() {
        var focusable = element[0].querySelector('.form-group [tabindex]');
        if (focusable && focusable.focus) {
          focusable.focus();
          // focusable.click();
          if($window.cordova && $window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.show();
          }
        }
      }
    }
  };

});
