angular.module('ib.directives')
.directive('ibFormElement', ['$parse', '$compile', '$http', '$templateCache', function($parse, $compile, $http, $templateCache) {
  var compiledArr = {
    default: $compile($templateCache.get('templates/forms/default.html')),
    select: $compile($templateCache.get('templates/forms/select.html')),
    selectQuick: $compile($templateCache.get('templates/forms/select-quick.html')),
    checkbox: $compile($templateCache.get('templates/forms/checkbox.html')),
    checkboxQuick: $compile($templateCache.get('templates/forms/checkbox-quick.html')),
    textarea: $compile($templateCache.get('templates/forms/textarea.html')),
    images: $compile($templateCache.get('templates/forms/images.html')),
    imagesQuick: $compile($templateCache.get('templates/forms/images-quick.html'))
  };

  var formElementHandler = function(scope, element, attrs) {
    var attrElement = $parse(attrs.form);
    scope.form = attrElement(scope) || [];

    var tpl;
    if (!scope.form.type) {
      tpl = 'default';
    }
    else {
      switch(scope.form.type){
        case 'text':
        case 'date':
          tpl = 'default';
          break;
        case 'string':
          tpl = 'default';
          break;
        case 'number':
        case 'range':
        case 'tel':
          // Use 'tel' keyboard to overcome the missing '.' bug on samsung devices
          tpl = 'default';
          break;
        case 'boolean':
          tpl = 'checkbox';
          break;
        default:
          tpl = scope.form.type;
          break;
      }
    }

    if (scope.quickFormObject && tpl + 'Quick' in compiledArr) {
      tpl = tpl + 'Quick';
    }

    if (tpl in compiledArr) {
      compiledArr[tpl](scope, function(clonedElement, scope){
//        $scope.$evalAsync(
//          function() {
            element.append(clonedElement);
//          }
//        )
      });
    }


  };

  return {
    restrict: 'E',
    link: formElementHandler
  };
}]);
