'use strict';
angular.module('ib.directives')
.directive('ibkeyboard', function ($parse) {

  function keyboardHandler(scope, element, attrs) {

    // Get settings from the 'keyboard' attribute.
    var keySettings = $parse(attrs.keyboard);
    scope.keyboard = keySettings(scope);

    // Click handlers.
    scope.keyPress = function(event) {
      var btn = angular.element(event.srcElement),
          action = btn.attr('data-action'),
          serial = scope.form && scope.form.serialNumber ? scope.form.serialNumber : '01',
          textarea = document.querySelector('[tabindex="' + serial + '"]');

      scope.caretPos = scope.caretPos || textarea.selectionStart;

      if (action == 'insertKey') {
        scope.form = scope.form || {};
        var insert = btn.attr('data-insert') + ' ',
            currVal = scope.form.currVal;

        // If focused update caretPos.
        if (textarea === document.activeElement) {
          scope.caretPos = textarea.selectionStart;
        }

        // If it has value update it.
        if (currVal) {
          scope.form.currVal = textarea.value.substring(0, scope.caretPos) + insert + textarea.value.substring(scope.caretPos);
        }
        else {
          scope.form.currVal = insert;
        }

        scope.caretPos = scope.caretPos + insert.length;

      }
      else if (action == 'clearText') {
        scope.form.currVal = '';
      }

      scope.$emit('form.updated', { modelValue: scope.form.currVal, form: scope.form });

    };
  }

  function keyboardTplHandler(element, attrs) {
    if (attrs.keyboard == 'settings.keyboard') {
      return 'templates/keyboard-binded.html';
    }
    else {
      return 'templates/keyboard.html';
    }
  }

  return {
    templateUrl: keyboardTplHandler,
    link: keyboardHandler
  };
});
