angular.module('ib.services')
.factory('AuthenticationService', function($rootScope, $http, authService, localStorageService, $log, DbService) {
  return {
    login: function(user) {
      if (user.username && user.password) {
        $http.post($rootScope.endPoint + '/user/login.json', { username: user.username, password: user.password }, { ignoreAuthModule: true, timeout: 300000, warningAfter: 5000})
          .success(function (data, status, headers, config) {
            if ('user' in data && 'field_client_nid_ref' in data.user) {
              localStorageService.set('clientId', data.user.field_client_nid_ref);
              DbService.insertConfValue("clientId", data.user.field_client_nid_ref);
              $rootScope.clientId = data.user.field_client_nid_ref;
            }
            $http.defaults.headers.cookie = data.session_name + '=' + data.sessid;
            $http.post($rootScope.tokenEndPoint , null, { ignoreAuthModule: true, timeout: 300000, warningAfter: 5000 })
              .success(function (data, status, headers, config) {
                localStorageService.set('token', data);
                localStorageService.set('username', user.username);
                localStorageService.set('keystring', user.password);
                DbService.insertConfValue("keystring", user.password);
                DbService.insertConfValue("username", user.username);

                $log.overrideExtraDef({'_userClientId' : $rootScope.clientId, '_userName' : user.username});
                $http.defaults.headers.common['X-CSRF-Token'] = data;
                $http.defaults.headers.put['X-CSRF-Token'] = data;
                // Need to inform the http-auth-interceptor that
                // the user has logged in successfully.  To do this, we pass in a function that
                // will configure the request headers with the authorization token so
                // previously failed requests(aka with status == 401) will be resent with the
                // authorization token placed in the header
                authService.loginConfirmed(data, function(config) {
                  return config;
                });
              })
          })
          .error(function (data, status, headers, config) {
            $rootScope.$broadcast('event:auth-login-failed', status);
          });
      }
      else {

        $rootScope.$broadcast('event:auth-login-failed', 401);
      }
    },
    logout: function() {
      $http.post($rootScope.endPoint + '/user/logout.json', null, {timeout: 300000, warningAfter: 5000}).success(function (data, status, headers, config) {
        $log.overrideExtraDef({'_userClientId' : 0, '_userName' : 'anonymous'});
        localStorageService.remove('token');
        localStorageService.remove('keystring');
        $rootScope.$broadcast('event:auth-logout-complete');
      });
    },
    loginCancelled: function() {
      authService.loginCancelled();
    }
  };
})
