'use strict';
angular.module('ib.services')
  .service('GotoService', function($location, $state, $ionicLoading, $log) {
    var startTime;
    var endTime;

    this.goTo = function (parentId, objId, tab, showLoading) {
      // ToDo handle goTo to current item freeze app.
      this.logStart();
      tab = tab || 'edit';
      if (tab === 'quick-edit') {
        this.goToQuickEdit(parentId, objId, showLoading);
      }
      else {
        this.goToTabs(parentId, objId, tab, showLoading);
      }
      this.ionicLoading(showLoading);
    };

    this.goToTabs = function(parentId, objId, tab) {
      if ($state.current.name.indexOf('app.job.obj.tab') == -1) {
        // Coming from another view (plot-list/quick-edit).
        $location.path($state.href('app.job.obj.tabs.tab-' + tab).replace('#', '')).search({parentId: parentId,objId: objId, tab:tab});
      }
      else {
        // Already in a tab view.
        $location.search({parentId: parentId, objId: objId, tab:tab});
      }
    };

    this.goToQuickEdit = function(parentId, objId, tab) {
      if ($location.path().indexOf('quick-edit') === -1) {
        // Coming from another view
        $location.path($state.href('app.job.obj.quick-edit').replace('#', '')).search({parentId: parentId,objId: objId, tab:tab});
      }
      else {
        // Coming from quick edit, different object, change search only.
        $location.search({parentId: parentId, objId: objId});
      }
    };

    this.ionicLoading = function(showLoading) {
      this.showLoading = showLoading || 'load';
      if (this.showLoading === 'load') {
        $ionicLoading.show();
        this.showLoading = true;
      }
    };

    this.logStart = function() {
      startTime = Date.now();
      $log.info('goto enter time ' + startTime, {'controllerStartTime' : startTime});
    };

    this.endGoto = function() {
      endTime = Date.now();
      $log.info('goto end time ' + Date.now(), {'controllerEndTime' : Date.now()});
      $log.info('goto total ' + startTime - endTime, {'totalTime' : startTime - endTime});
      if (this.showLoading) {
        $ionicLoading.hide();
      }
    };
});
