angular.module('ib.services')


  .service('HelperService', function($ionicPlatform, $cordovaNetwork, $q, $filter, $log, localStorageService) {
    var ok = function(value) {

    }
    var error = function() {

    }
    this.setLocalValue = function(key, val) {
      try {
        var prefs = plugins.appPreferences;
        prefs.fetch (ok, fail, 'key');
      } catch (e) {
        return localStorageService.get('username');
      }
    }
    this.getLocalValue = function(key, val) {

    }

    var getDateFormatsFallback = function() {
      return {'date short': 'd/M/yy', 'date medium': 'd MMMM yyyy', 'date and time short': 'H:mm - d/M/yy', 'date default': 'yyyy-MM-dd'};
    };

    this.getDateFormats = function() {
      var dateMap = {};

      var deferred = $q.defer();
      try {
        var options;
        var self = this;
        var successCallbackDateShort = function (date) {
          dateMap['date short'] = date.pattern;
          dateMap['date default'] = 'yyyy-MM-dd';
          self.dateMap = dateMap;
          deferred.resolve(true);
        }

        var successCallbackDateMedium = function (date) {
          dateMap['date medium'] = date.pattern;
          options = {formatLength: 'short', selector: 'date'};
          navigator.globalization.getDatePattern(successCallbackDateShort, errorCallback, options);
        }

        var successCallbackDefault = function (date) {
          dateMap['date and time short'] = date.pattern;
          options = {formatLength: 'medium', selector: 'date'};
          navigator.globalization.getDatePattern(successCallbackDateMedium, errorCallback, options);
        }

        var errorCallback = function (err) {
          $log.error(err);
        }

        options = {formatLength: 'short', selector: 'date'};

        navigator.globalization.getDatePattern(successCallbackDefault, errorCallback);
      } catch (e) {
        this.dateMap = getDateFormatsFallback();

        deferred.resolve(true);
      }

      return deferred.promise;
    }
    this.formatDate = function(date, selector, formatLength) {
      var formatStr = '';
      try {
        formatStr = $filter('date')(date, this.dateMap[selector + ' ' + formatLength]);
        return formatStr;
      } catch (e) {
        return '';
      }
    }

    this.isOnlineCheck = function() {
      var isOnline;
      try {
        isOnline = $cordovaNetwork.isOnline();
      } catch (e) {
        isOnline = navigator.onLine;
      }
      return isOnline;
    };

    this.checkConnectionMode = function() {
      var connection;
      $ionicPlatform.ready(function() {
        try {
          var connectionType = $cordovaNetwork.getNetwork();
          if (connectionType == Connection.WIFI) {
            connection = 1;
          }
          else if (connectionType == Connection.NONE) {
            connection = -1;
          }
          else {
            connection = 0;
          }
        } catch (e) {
          connection = navigator.onLine ? 1 : -1;
        };
      });
      return connection;
    }

    this.getStatusClass = function(status) {
      status = parseInt(status);
      var statusClass;
      switch (status) {
        case 0:
          statusClass = "pending";
          break;
        case 1:
          statusClass = "inProgress";
          break;
        case 2:
          statusClass = "completed";
          break;
        case 3:
          statusClass = "done";
          break;
        case 4:
          statusClass = "sync";
          break;
      }
      return statusClass;
    };
})
