angular.module('ib.services')
.service('InitService', function($rootScope, $q, DbService, UpdateService, HelperService, RestService, $log, localStorageService) {
  var deferred = $q.defer();
  var _init = false;
  this.getInit = function() {
    return _init;
  }
  $rootScope.$on('app.run', function() {
    $rootScope.clientId = localStorageService.get('clientId' || 0);
    $log.setExtraDef($rootScope.ibVersion, $rootScope.ibPackage);
    $log.overrideExtraDef({'_userClientId' : $rootScope.clientId, '_userName' : localStorageService.get('username') || 'anonymous'});
    var needUpdate = false;
    localStorageService.set('appVerU', $rootScope.ibVersion);
    // LogDbService.run(needUpdate);
    DbService.run(needUpdate).then(function() {
      // LogSelectDbService.run();
      RestService.setHttp();
      HelperService.getDateFormats().then(function(res){
        UpdateService.run().then(function() {
          _init = true;
          deferred.resolve();
        });
      });
    });

  });
  this.run = function() {
    return deferred.promise;
  };
})
