angular.module('ib.services')
.factory('JobsFactory', function($q, DbService, RestService, HelperService, $cordovaFile, $rootScope) {
    var service = {};
    service.job = {};
    service.init = false;
    //var getJobData = function(id) {
    //  return DbService.selectJobData(id);
    //}
    var getJobData = function(id) {
      var deferred = $q.defer();
      var res = {data: ''};
      DbService.selectJobData(id).then(function(results) {
        res.status = results.rows.item(0).status;
        if ($rootScope.mode == "mobile") {
          $cordovaFile.readAsText(cordova.file.dataDirectory, id + ".json")
            .then(function (file) {
              res.data = file;
              deferred.resolve(res);
            }, function (error) {
              deferred.resolve(res);
            });
        }
        else {
          res.data = results.rows.item(0).data;
          deferred.resolve(res);
        }
      });
        return deferred.promise;
    }

    var getJobs = function(deferred) {
      DbService.selectJobs().then(function(results) {
        var len = results.rows.length, i;
        var items = [];
        for (i = 0; i < len; i++){
          var tempItem = results.rows.item(i);
          var statusClass = HelperService.getStatusClass(tempItem.status);
          var o = {id: tempItem.id, jobDate: tempItem.jobDate, jobName: tempItem.jobName, jobProperties: JSON.parse(tempItem.jobProperties), status: tempItem.status, statusClass:statusClass};
          items.push(o);
        }
        deferred.resolve(items);
      });

    }
    service.setActiveJob = function(id) {
      var deferred = $q.defer();
      service.job.id = id;
      getJobData(id).then(function(result) {
        service.job.data = JSON.parse(result.data);
        service.job.data.JobUniqueId = id;
        service.job.status = result.status;
        deferred.resolve(service.job);
      });
      return deferred.promise;
    }

    service.getJobs = function() {
      var deferred = $q.defer();
      getJobs(deferred);
      return deferred.promise;
    };
    service.refreshJobs = function() {
      service.init = true;
      return RestService.getJobsFromServer();
    };

    return service;
})
