'use strict';
angular.module('ib.services')
.service('UpdateService', function($rootScope, localStorageService, DbService, RestService, $q, $log, $cordovaFile) {
  var moveDataToFiles = function () {
    var deferred = $q.defer();
    if ($rootScope.mode != "mobile") {
      deferred.resolve();
    }
    var prom = [];

    DbService.selectJobsData().then(function(results){
      if (results.rows.length > 0) {
        var len = results.rows.length, i;
        for (i = 0; i < len; i++){
          prom.push($cordovaFile.writeFile(cordova.file.dataDirectory, results.rows.item(i).id + ".json", results.rows.item(i).data, true))
        }
      }
      $q.all(prom).then(function () {
        deferred.resolve();
        return;
      })
    })
    return deferred.promise;
  };
  var deleteCache = function () {
    var deferred = $q.defer();
    DbService.deleteFormsCache().then(function(){
      DbService.selectJobsData().then(function(results){
        if (results.rows.length > 0) {
          var len = results.rows.length, i;
          for (i = 0; i < len; i++){
            var data = JSON.parse(results.rows.item(i).data);
            var formsList = RestService.getFormsList(results.rows.item(i).id, data.ScObjDefList.ScObjDef, data.JobProperties.JobProperty);
            DbService.insertJobForms(formsList);

            var pFields = [];
            var parentsList = [];
            RestService.processJobFields(results.rows.item(i).id, data.ScoredObjectsList.ScoredObject, pFields, parentsList);
            var fieldsList = RestService.getFieldsList(results.rows.item(i).id, parentsList, data);
            DbService.insertJobFieldsChildes(fieldsList);
          }
        }

        deferred.resolve();
      });
    });
    return deferred.promise;
  };

  // Updates list.
  var Updates = {
    1: function() {},
    2: function() {},
    10: function() {
      return DbService.clearJobsAsync();
    },
    20: function() {

      return moveDataToFiles();
    }
  };

  this.run = function() {
    var updating = false;
    var deferred = $q.defer();
    var lastKey = localStorageService.get('update', 0),
        nextKey = false,
        prom = [];

    if (lastKey === 0) {
      // Install mode
      Object.keys(Updates).forEach(function(key){
        nextKey = Math.max(nextKey || 0, key);
        localStorageService.set('update', nextKey);
      });
    }
    else {
      // Update mode
      Object.keys(Updates).forEach(function(key){
        if (lastKey < key) {
          if (updating === false) {
            updating = true;
//            prom.push(deleteCache());
          }
          nextKey = Math.max(nextKey || 0, key);
          prom.push(Updates[key]());
          $log.log('run app update function number ' + key.toString(), {'upgrade number' : key.toString()});
        }
      });
    }
    if (nextKey) {
      localStorageService.set('update', nextKey);
    }
    $q.all(prom).then(function () {
      deferred.resolve();
    });

    return deferred.promise;
  };

});
